;		crackme2
;		   by
;		 cronos
;
;
; note: after compilation strings,etc are hidden with
; a separate c program - the primer.
;
; whole thing is basically a FORTH program.

	.486
        .model use16 tiny
	.code
        org 100h

;----------------------------------------------------------
; predefined constants
;----------------------------------------------------------
passval	equ	7777h
maxslen equ	100h
fudge	equ	79dfh

;----------------------------------------------------------
;Prog written as FORTH but with no dict headers.
;Notation:
; # a b -->
; means a is top of stack, b is next on stack, both are
;    removed by proc.
;Main interpreter and regs used:
;----------------------------------------------------------
; si=ip
; bp=return stack 
; memory map (single segment):
;  100h program
;    ?  user variables
; 8000h return stack (grows down)
; fffeh ordinary stack (grows down)
;----------------------------------------------------------

start:				; set up
;	mov	ah,8		; temp, for softice
;	int	21h		; debug only

	mov	bp,8000h	; ret stack
        mov     si,offset main  ; now go!
	jmp	next


docol:  sub	bp,2
        mov     [bp],si
	mov	si,dx
next:	mov	bx,[si]
	add	si,2
	mov	dx,bx
	add	dx,2
	jmp	word ptr [bx]

exit:	dw	$+2
        mov     si,[bp]
	add	bp,2
	jmp	next
	
;----------------------------------------------------------
;	:r # --> r ;
;----------------------------------------------------------
r:	dw 	$+2
        push    word ptr [bp]
	jmp	next

;----------------------------------------------------------
;	:fromr # --> r ;
;----------------------------------------------------------
fromr:	dw 	$+2
        push    word ptr [bp]
	add	bp,2
	jmp	next

;----------------------------------------------------------
;	:tor # r --> ;
;----------------------------------------------------------
tor:	dw 	$+2
	pop	ax
	sub	bp,2
        mov	[bp],ax
	jmp	next

;----------------------------------------------------------
;	:0 # --> 0 ;
;----------------------------------------------------------
zero:	dw 	$+2
	push	0
	jmp	next

;----------------------------------------------------------
;	:lit # --> n ;
;----------------------------------------------------------
lit:	dw 	$+2
	mov	ax,[si]
	add	si,2
	push	ax
	jmp	next

;----------------------------------------------------------
;	:swap # a b --> b a ;
;----------------------------------------------------------
swap:	dw	$+2
	pop	ax
	pop	bx
	push	ax
	push	bx
	jmp	next

;----------------------------------------------------------
;	:drop # a --> ;
;----------------------------------------------------------
drop:	dw	$+2
	pop	ax
	jmp	next

;----------------------------------------------------------
;	:dup # a --> a a ;
;----------------------------------------------------------
dup_:   dw      $+2
	pop	ax
	push	ax
	push	ax
	jmp	next

;----------------------------------------------------------
;	:over # b a --> a b a ;
;----------------------------------------------------------
over:	dw	$+2
	pop	ax
	pop	bx
	push	bx
	push	ax
	push	bx
	jmp	next

;----------------------------------------------------------
;	:2over # c b a --> a c b a ;
;----------------------------------------------------------
over2:	dw	$+2
        mov     bx,sp
        push    word ptr [bx+4]
	jmp	next

;----------------------------------------------------------
;	:3over # d c b a --> a d c b a ;
;----------------------------------------------------------
over3:	dw	$+2
        mov     bx,sp
        push    word ptr [bx+6]
	jmp	next

;----------------------------------------------------------
;	:cat # a --> (a) ;
;----------------------------------------------------------
cat:	dw	$+2
        pop     bx
        movzx   ax,byte ptr [bx]
	push	ax
	jmp	next

;----------------------------------------------------------
;	:cstor # 0a b --> # (b)=0a
;----------------------------------------------------------
cstor:	dw	$+2
	pop	ax
        pop     bx
        mov     byte ptr [bx],al
	jmp	next

;----------------------------------------------------------
;	:at # a --> (a) ;
;----------------------------------------------------------
at:	dw	$+2
        pop     bx
        mov     ax,[bx]
	push	ax
	jmp	next

;----------------------------------------------------------
;	:stor # a b --> # (b)=a
;----------------------------------------------------------
stor:	dw	$+2
	pop	ax
	pop	bx
	mov	[bx],ax
	jmp	next

;----------------------------------------------------------
;	:plusone # a --> a+1 ;
;----------------------------------------------------------
plusone:
	dw	$+2
        pop     bx
        inc     bx
        push    bx
	jmp	next

;----------------------------------------------------------
;       :minusone # a --> a-1 ;
;----------------------------------------------------------
minusone:
	dw	$+2
        pop     bx
        dec     bx
        push    bx
	jmp	next

;----------------------------------------------------------
;	:add # a b --> a+b ;
;----------------------------------------------------------
add_:	dw	$+2
	pop	ax
	pop	dx
	add	ax,dx
	push	ax
	jmp	next

;----------------------------------------------------------
;	:sub # b a --> a-b ;
;----------------------------------------------------------
sub_:	dw	$+2
	pop	dx
	pop	ax
	sub	ax,dx
	push	ax
	jmp	next

;----------------------------------------------------------
;	:multiply # a b --> a*b ;
;----------------------------------------------------------
multiply:
	dw	$+2
	pop	ax
	pop	dx
        mul     dx
	push	ax
	jmp	next

;----------------------------------------------------------
;	:branch # (else) - unconditional jump, as for repeat.
;----------------------------------------------------------
bran:	;dw	$+2
	;add	si,[si]
	;jmp	next

;----------------------------------------------------------
;	:repeat # unconditional jump
;	;
;----------------------------------------------------------
repeat:	dw	$+2
	add	si,[si]
	jmp	next

;----------------------------------------------------------
;	:while # conditional jump
;	;
;----------------------------------------------------------
if_:
while_:	dw	$+2
	pop	ax
	or	ax,ax
        jz     repeat+2
	add	si,2
	jmp	next

;----------------------------------------------------------
;	:if # conditional jump
;----------------------------------------------------------
;if_:	dw	$+2
;	pop	ax
;	or	ax,ax
;	jz	repeat+2
;	add	si,2
;	jmp	next

;----------------------------------------------------------
;	:emit # c --> 
;	;
;----------------------------------------------------------
emit:	dw	$+2
	pop	dx
	mov	ah,2
	int	21h
	jmp	next

;----------------------------------------------------------
;	:key # --> c
;	;
;----------------------------------------------------------
key:	dw	$+2
	mov	ah,8
	int	21h
	mov	ah,0
	push	ax
	jmp	next

;----------------------------------------------------------
;	:quit
;	;
;----------------------------------------------------------
quit:	dw	$+2
	mov	ax,4ch
	int	21h

;----------------------------------------------------------
;	:strlen # strptr --> length
;		0 swap
;		begin{ dup c@ }while{ swap ++ swap ++ }repeat
;		drop
;	;
;----------------------------------------------------------
strlen:	dw	offset docol
	dw	offset zero
	dw	offset swap
@1:	dw	offset dup_
	dw	offset cat
	dw	offset while_
	dw	@2-$
	dw	offset swap
	dw	offset plusone
	dw	offset swap
	dw	offset plusone
        dw      offset repeat
	dw	@1-$
@2:	dw	offset drop
	dw	offset exit

;----------------------------------------------------------
;	:decrypt_byte # byte --> dec_byte
;		37 mul
;	;
;----------------------------------------------------------
decbyte:dw      offset docol
	dw	offset lit
	dw	31
	dw	offset multiply
	dw	offset exit

;----------------------------------------------------------
;	:decrypt_string # strptr --> strptr
;		dup
;		begin{ dup c@ dup }while{ decrypt_byte over swap c! ++ }repeat
;		drop drop
;	;
;----------------------------------------------------------
decstr:	dw	offset docol
	dw	offset dup_
@3:	dw	offset dup_
	dw	offset cat
	dw	offset dup_
	dw	offset while_
	dw	@4-$
	dw	offset decbyte
	dw	offset over
	dw	offset swap
	dw	offset cstor
	dw	offset plusone
	dw	offset repeat
	dw	offset @3-$
@4:	dw	offset drop
	dw	offset drop
	dw	offset exit

;----------------------------------------------------------
;	:strout # strptr -->
;		begin{ dup c@ }while{ dup c@ emit ++ }repeat
;		drop
;	;
;----------------------------------------------------------
strout:	dw	offset docol
@6:	dw	offset dup_
	dw	offset cat
	dw	offset while_
	dw	@7-$
	dw	offset dup_
	dw	offset cat
	dw	offset emit
	dw	offset plusone
	dw	offset repeat
	dw	@6-$
@7:	dw	drop
	dw	offset exit

;----------------------------------------------------------
;	:." emit string"
;		r dup @ r> + >r ++ ++ #decrypt_string strout
;	;
;----------------------------------------------------------
dotstr:	dw	offset docol
	dw	offset r
	dw	offset dup_
	dw	offset at
	dw	offset fromr
	dw	offset add_
	dw	offset tor
	dw	offset plusone
	dw	offset plusone
	dw	offset decstr
	dw	offset strout
	dw	offset exit

;----------------------------------------------------------
;	:username # --> username (user variable)
;	;
;----------------------------------------------------------
username:
	dw	offset docol
	dw	offset lit
	dw	offset user	; user+0
	dw	offset exit

;----------------------------------------------------------
;	:userpass # --> userpass (user variable)
;	;
;----------------------------------------------------------
userpass:
	dw	offset docol
	dw	offset lit
	dw	offset user+maxslen	; user+maxslen
	dw	offset exit

;----------------------------------------------------------
;	:strout_pass
;		." Access granted" cr emit
;	;
;----------------------------------------------------------
strout_pass:
	dw	offset docol
	dw	offset dotstr
	dw	@12-$
	db	'Access Granted',0d,0
@12:	dw	offset exit

;----------------------------------------------------------
;	:strout_fail
;		." Access denied" cr emit
;	;
;----------------------------------------------------------
strout_fail:
	dw	offset docol
	dw	offset dotstr
	dw	@13-$
	db	'Access Denied',0d,0
@13:	dw	offset exit

;----------------------------------------------------------
;	:== # a b --> bool (true if a==b)
;	;
;----------------------------------------------------------
testeq:	dw	$+2
	pop	ax
	pop	bx
	cmp	ax,bx
	jz	equalr
	push	0h		; false
	jmp	next
equalr:	push	1h		; true
	jmp	next

;----------------------------------------------------------
;       :< # a b --> bool (true if a<b)
;	;
;----------------------------------------------------------
lessthan:
        dw      $+2
	pop	ax
	pop	bx
	cmp	ax,bx
        jb      lt_
	push	0h		; false
	jmp	next
lt_:    push    1h              ; true
	jmp	next

;----------------------------------------------------------
;	:!= # a b --> bool (true if a!=b)
;	;
;----------------------------------------------------------
nequal:	dw	$+2
	pop	ax
	pop	bx
	cmp	ax,bx
	jnz	neq
	push	0h		; false
	jmp	next
neq:	push	1h		; true
	jmp	next

;----------------------------------------------------------
;	:cls # clearscreen (cursor home,clear to end)
;	;
;----------------------------------------------------------
cls:	dw	$+2
	mov	ax,3
	int	10h
	jmp	next

;----------------------------------------------------------
;	:crlf # carriage return, linefeed
;		0d emit 0a emit
;	;
;----------------------------------------------------------
crlf:	dw	offset docol
	dw	offset lit
	dw	0dh
	dw	offset emit
	dw	offset lit
	dw	0ah
	dw	offset emit
	dw	offset exit

;----------------------------------------------------------
;	:hash	# pass user -> hash
;		# algorithm(C):
;		
;		# if (strlen(user)==strlen(pass))
;		# { hash=0;
;		#   i=0;
;		#   while(user[i])
;		#   { hash=hash*3+user[i]-pass[i]+147;
;		#     i++;
;		#   }
;		#   hash=hash*1471+fudge;   
;		# }
;		# else hash=0
;		
;		over over strlen swap strlen equal
;		if
;		  0
;		  0      #stack: i hash pass user
;		  begin{
;		    3over over + c@
;		  }while{
;		    swap 3 * 147 +
;		    3over 2over + c@ +
;		    2over 2over + c@ -
;		    swap ++
;		  }repeat
;		  drop
;		  1471 * fudge +
;		else
;		  0
;		then
;		swap drop swap drop
;	;
;----------------------------------------------------------
hash:	dw	offset docol
	dw 	offset over
	dw	offset over
	dw	offset strlen
	dw	offset swap
	dw	offset strlen
	dw	offset testeq
	dw	offset if_
	dw	@19-$
	dw	offset zero
	dw	offset zero
@20:	dw	offset over3
	dw	offset over
	dw	offset add_
	dw	offset cat
	dw	offset while_
	dw	@21-$
	dw	offset swap
	dw	offset lit
	dw	3
	dw	offset multiply
	dw	offset lit
	dw	147
	dw	offset add_
	dw	offset over3
	dw	offset over2
	dw	offset add_
	dw	offset cat
	dw	offset add_
	dw	offset over2
	dw	offset over2
	dw	offset add_
	dw	offset cat
	dw	offset sub_
	dw	offset swap
	dw	offset plusone
	dw	offset repeat
	dw	@20-$
@21:	dw	offset drop
	dw	offset lit
	dw	1471
	dw	offset multiply
	dw	offset lit
	dw	fudge
	dw	add_
	dw	offset bran
	dw	@22-$
@19:	dw	offset zero
@22:	dw	offset swap
	dw	offset drop
	dw	offset swap
	dw	offset drop
	dw	offset exit

;----------------------------------------------------------
;		#:inpstr # str maxlen -->
;		# algorithm (C):
;
;		# str[0]=0;
;		# currentpos=0;
;		# while((key=getkey())<>return)
;		# { if(key==8)
;		#   { if (currentpos)
;		#     { currentpos--;
;		#       str[currentpos]=0;
;		#	echo(key)
;		#     }
;		#   }
;		#   else
;		#   { if (currentpos<strmaxlen)
;		#     { str[currentpos]=encrypt(key);
;		#       currentpos++;
;		#	str[currentpos]=0;
;		#	echo(key);
;		#     }
;		#   }
;		# }
;
;
;		#summary:
;	:inpstr # str maxlen -->
;		dup 0 c!
;		0
;		begin{
;		  key	# stack: key cpos str maxlen
;		  dup 0d !=
;		}while{		
;		  dup 8 == 
;		  if 
;		     over 0 !=
;		     if
;			swap -- swap
;			2over 2over + 0 c!
;			dup emit
;		     then	
;		  else
;		     3over 2over <
;		     if
;			2over 2over + over 43 multiply c!
;			swap ++ swap
;			2over 2over + 0 c!
;			dup emit
;		     then 
;		  then
;		  drop
;		}repeat
;		drop drop drop drop
;	;
;----------------------------------------------------------
inpstr:	dw	offset docol
	dw	offset dup_
	dw	offset zero
	dw	offset cstor
	dw	offset zero
@15:	dw	offset key
	dw	offset dup_
	dw	offset lit
	dw	0dh
	dw	offset nequal
	dw	offset while_
	dw	@16-$
	dw	offset dup_
	dw	offset lit
	dw	8
	dw	offset testeq
	dw	offset if_
	dw	@17-$
	dw	offset over
	dw	offset zero
	dw	offset nequal
	dw	offset if_
	dw	@18-$
	dw	offset swap
	dw	offset minusone
	dw	offset swap
	dw	offset over2
	dw	offset over2
	dw	offset add_
	dw	offset zero
	dw	offset cstor
	dw	offset dup_
	dw	offset emit
	dw	offset bran
	dw	@18-$
@17:	dw	offset over3
	dw	offset over2
	dw	offset lessthan
	dw	offset if_
	dw	@18-$
	dw	offset over2
	dw	offset over2
	dw	offset add_
	dw	offset over
	dw	offset lit
	dw	43
	dw	offset multiply
	dw	offset cstor
	dw	offset swap
	dw	offset plusone
	dw	offset swap
	dw	offset over2
	dw	offset over2
	dw	offset add_
	dw	offset zero
	dw	offset cstor
	dw	offset dup_
	dw	offset emit
@18:	dw	offset drop
	dw	offset repeat
	dw	@15-$
@16:	dw	offset drop
	dw	offset drop
	dw	offset drop
	dw	offset exit


;----------------------------------------------------------
; 	:Main
;		cls
;		." Cronos systems (c) Cronos" crlf 
;		." Authorised access only" crlf crlf
;		." Username: "
;		maxstrlen user_namebuff inpstr crlf
;		." Password: "
;		maxstrlen user_passbuff inpstr crlf crlf
;		user_namebuff user_passbuff hash
;		passval ==
;		if   strout_pass
;		else strout_fail
;		then
;		quit
;	;
;----------------------------------------------------------
main:	dw	$+2			; cold start-chug
	dw	offset docol
	dw	offset cls
	dw	offset dotstr
	dw	@5-$
	db	'Cronos Systems (c) Cronos',0
@5:	dw	offset crlf
	dw	offset dotstr
	dw	@14-$
	db	'Authorised Access Only',0
@14:	dw 	offset crlf
	dw	offset crlf
	dw	offset dotstr
	dw	@8-$
	db	'Username   : ',0	; encrypt strings later
@8:	dw	offset lit
	dw	maxslen
	dw	offset username
	dw	offset inpstr
	dw	offset crlf
	dw	offset dotstr
	dw	@9-$
	db	'Access Code: ',0
@9:	dw	offset lit
	dw	maxslen
	dw	offset userpass
	dw	offset inpstr
	dw	offset crlf
	dw	offset crlf		; change to cls later - never done!!
	dw	offset username
	dw	offset userpass
	dw	offset hash
	dw	offset lit
	dw	passval
	dw	offset testeq
	dw	offset if_
	dw	@10-$
	dw	offset strout_pass
	dw	offset bran
	dw	@11-$
@10:	dw	offset strout_fail
@11:	dw	offset quit
user:
;----------------------------------------------------------
        end start

