Input 4 equations:
    A1*X + B1*Y + C1*Z + D1*T = E1
    A2*X + B2*Y + C2*Z + D2*T = E2
    A3*X + B3*Y + C3*Z + D3*T = E3
    A4*X + B4*Y + C4*Z + D4*T = E4
Output: X,Y,Z,T

Solution by Matrix calculations:
-----------------------------------------
dGEN:                   
         A1  B1  C1  D1 
         A2  B2  C2  D2 
         A3  B3  C3  D3 
         A4  B4  C4  D4 
                        
                                                                    
         B2  C2  D2      B1  C1  D1      B1  C1  D1      B1  C1  D1 
   = A1* B3  C3  D3 -A2* B3  C3  D3 +A3* B2  C2  D2 -A4* B2  C2  D2 
         B4  C4  D4      B4  C4  D4      B4  C4  D4      B3  C3  D3 
                                                                    
-----------------------------------------
dX:                     
         E1  B1  C1  D1 
         E2  B2  C2  D2 
         E3  B3  C3  D3 
         E4  B4  C4  D4 
                        
                                                                    
         B2  C2  D2      B1  C1  D1      B1  C1  D1      B1  C1  D1 
   = E1* B3  C3  D3 -E2* B3  C3  D3 +E3* B2  C2  D2 -E4* B2  C2  D2 
         B4  C4  D4      B4  C4  D4      B4  C4  D4      B3  C3  D3 
                                                                    
-----------------------------------------
dY:                     
         A1  E1  C1  D1 
         A2  E2  C2  D2 
         A3  E3  C3  D3 
         A4  E4  C4  D4 
                        
                                                                    
         E2  C2  D2      E1  C1  D1      E1  C1  D1      E1  C1  D1 
   = A1* E3  C3  D3 -A2* E3  C3  D3 +A3* E2  C2  D2 -A4* E2  C2  D2 
         E4  C4  D4      E4  C4  D4      E4  C4  D4      E3  C3  D3 
                                                                    
-----------------------------------------
dZ:                     
         A1  B1  E1  D1 
         A2  B2  E2  D2 
         A3  B3  E3  D3 
         A4  B4  E4  D4 
                        
                                                                    
         B2  E2  D2      B1  E1  D1      B1  E1  D1      B1  E1  D1 
   = A1* B3  E3  D3 -A2* B3  E3  D3 +A3* B2  E2  D2 -A4* B2  E2  D2 
         B4  E4  D4      B4  E4  D4      B4  E4  D4      B3  E3  D3 
                                                                    
-----------------------------------------
dT:                     
         A1  B1  C1  E1 
         A2  B2  C2  E2 
         A3  B3  C3  E3 
         A4  B4  C4  E4 
                        
                                                                    
         B2  C2  E2      B1  C1  E1      B1  C1  E1      B1  C1  E1 
   = A1* B3  C3  E3 -A2* B3  C3  E3 +A3* B2  C2  E2 -A4* B2  C2  E2 
         B4  C4  E4      B4  C4  E4      B4  C4  E4      B3  C3  E3 
                                                                    
-----------------------------------------

        dX                   dY                  dZ                   dT
 X:=     ;    Y:=     ;   Z:=          T:= 
       dGEN                 dGEN                dGEN                 dGEN

-----------------------------------------
3x3 Matrix:
                    
         F1  G1  H1 
         F2  G2  H2 
         F3  G3  H3 
                    

          F1  G1  H1  F1  G1
            \   \/  \/   /
          F2  G2  H2  F2  G2
             /  \/  \/  \
          F3  G3  H3  F3  G3

   = [ F1*G2*H3 + G1*H2*F3 + H1*F2*G3 ]
     -[ G1*F2*H3 + F1*H2*G3 + H1*G2*F3 ]

