unit Patch;

interface

const
  BytesToPatch: array [1..10] of Record 		   { 10 bytes to patch          }
		Offset: Longint;			   { Offset to patch            }
		NewByte: Byte;				   { Replacemnet byte           }
		end = ((Offset: $00000608; NewByte: $90),  { Nop Byte 1 Of First Call   }
		       (Offset: $00000609; NewByte: $90),  { Nop Byte 2 Of First Call   }
		       (Offset: $0000060A; NewByte: $90),  { Nop Byte 3 Of First Call   }
		       (Offset: $0000060B; NewByte: $90),  { Nop Byte 4 Of First Call   }
		       (Offset: $0000060C; NewByte: $90),  { Nop Byte 5 Of First Call   }
		       (Offset: $00000654; NewByte: $90),  { Nop Byte 1 Of Second Call  }
		       (Offset: $00000655; NewByte: $90),  { Nop Byte 2 Of Second Call  }
		       (Offset: $00000656; NewByte: $90),  { Nop Byte 3 Of Second Call  }
		       (Offset: $00000657; NewByte: $90),  { Nop Byte 4 Of Second Call  }
		       (Offset: $00000658; NewByte: $90)); { Nop Byte 5 Of Second Call  }	

procedure ApplyPatch(FileToPatch: String);
procedure WriteBytes(var F: File);

implementation

procedure ApplyPatch(FileToPatch: String);
var
  TheFile: File;
begin
  Assign(TheFile, FileToPatch);                    { Open file }
  {$I-} Reset(TheFile, 1); {$I+}
  If IOResult <> 0 then                            { If error when opening }
  begin 
    WriteLn;                                       { file then             }
    WriteLn('Unable To Patch File');               { display error and     }
    Halt(1);                                       { exit                  }
  end;
  WriteLn;
  Write('Patching ');
  WriteBytes(TheFile);                             { Start patching file }
  Write('Finished. File Successfully Patched!');   { Success }
end;

procedure WriteBytes(var F: File);
var
  I:  Integer;                               { Counter }
  Ch: Char;                                  { Byte Holder }
begin
  For I := 1 to 10 do                        { 10 Bytes to write }
  begin
    Write('. ');                             { Show progress }
    Seek(F, BytesToPatch[I].Offset);         { Seek to specific offset }
    Ch := Char(BytesToPatch[I].NewByte);     { Select NewByte }
    BlockWrite(F, Ch, 1);                    { Patch OldByte with Newbyte }
  end;
end;

end.